# $Id: geomview.spec,v 1.15 2004/09/14 13:59:21 rexdieter Exp $

%define xforms_ver 0:1.0
%define maniview_ver 2.0.0
%define orrery_ver 0.9.3

Name:    geomview	
Summary: An interactive 3D viewing program
Epoch:	 0
Version: 1.8.1
Release: 0.fdr.10%{?dist_tag}.2
License: LGPL
Url:     http://www.geomview.org/
#Url:	 http://sourceforge.net/projects/geomview/
Group:   Applications/Engineering
Source:	 http://dl.sourceforge.net/sourceforge/geomview/geomview-1.8.1.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

Source1: geomview.desktop
Source2: geomview.png

# Other plugins
Source10: http://dl.sourceforge.net/geomview/orrery-%{orrery_ver}.tar.gz
Source11: http://dl.sourceforge.net/geomview/maniview-%{maniview_ver}.tar.gz
 
## Patches
# put moduledir and data in sane locations
Patch1: geomview-1.8.1-rh.patch
# from the "patches" section of http://sourceforge.net/projects/geomview/
Patch2: geomview-1.8.1-cH-2.diff

BuildRequires: desktop-file-utils
BuildRequires: autoconf213 automake14 libtool flex
BuildRequires: openmotif-devel
# For libGL/libGLU (yuck, but I see no other way -- Rex)
BuildRequires: XFree86-devel libGL.so.1 libGLU.so.1

Requires(post): /sbin/install-info
Requires(preun): /sbin/install-info

## XForms configuration
# use xforms by default, unless rpmbuild --without xforms
%{!?_without_xforms:%{?!_with_xforms:%define _with_xforms --with-xforms}}
## plugins, default to yes, unless rpmbuild --without pluginname
# default plugins
#{?_without_xforms:Obsoletes: %{name}-plugins < %{epoch}:%{version}-%{release}}
# maniview (requires xforms)
%{?_without_xforms:%define _without_maniview --without-maniview}
%{!?_without_maniview:%define _with_maniview --with-maniview}
#{?_without_maniview:Obsoletes: %{name}-maniview < %{epoch}:%{maniview_ver}-%{release}}
# orrery
%{!?_without_orrery:%define _with_orrery --with-orrery}
#{?_without_orrey:Obsoletes: %{name}-orrery < %{epoch}:%{orrery_ver}-%{release}}

%description
Geomview is an interactive 3D viewing program for Unix. It lets you view and 
manipulate 3D objects: you use the mouse to rotate, translate, zoom in and out, 
etc. It can be used as a standalone viewer for static objects or as a display 
engine for other programs which produce dynamically changing geometry. It can 
display objects described in a variety of file formats. It comes with a wide 
selection of example objects, and you can create your own objects too.


%if "%{?_with_xforms:1}" == "1"
%package plugins
Group:   Applications/Engineering
Summary: %{name} plugins
Requires: %{name} = %{epoch}:%{version}
BuildRequires: xforms-devel >= %{xforms_ver}
%description plugins 
Geomview default plugins
%endif

%if "%{?_with_orrery:1}" == "1"
%package orrery
Group:	 Applications/Engineering
Summary: Solar System Simulator for Geomview
Requires: %{name} = %{epoch}:%{version}
Requires: tk
Obsoletes: orrery < %{epoch}:%{orrery_ver}-%{release}
Provides:  orrery = %{epoch}:%{orrery_ver}-%{release}
%description	orrery
The Orrery is Geomview module which is a digital model of the solar
system, named for the mechanical models of the same name (often you'll
see one with just the Sun, Earth and Moon, as little balls supported
on wires); the first such was built for the fourth Earl of Orrery in
the 1700's.  This one includes all nine planets, some of their
satellites, and a few recent comets.
%endif

%if "%{?_with_maniview:1}" == "1"
%package maniview
Group:	 Applications/Engineering
Summary: a Geomview module for viewing 3D manifolds	
Requires: %{name} = %{epoch}:%{version}
BuildRequires: xforms-devel >= %{xforms_ver}
Obsoletes: maniview < %{epoch}:%{maniview_ver}-%{release}
Provides: maniview = %{epoch}:%{maniview_ver}-%{release}
%description maniview
a Geomview module for viewing 3D manifolds.
%endif


%prep
%setup -q %{?_with_orrery: -a 10} %{?_with_maniview: -a 11}

%patch1 -p1 -b .rh
%patch2 -p1 -b .gcc3

libtoolize --force
aclocal-1.4 -I ./m4
automake-1.4
autoconf-2.13
autoheader-2.13

# Move misc plugins to correct location
%{?_with_orrery:(  mv orrery* src/bin; ln -s src/bin/orrery*    	) }
%{?_with_maniview:(mv maniview* src/bin; ln -s src/bin/maniview*	)}


%build

%{?CCC:export %{CCC}}
%{?CXX:export %{CXX}}
%configure \
  %{?_with_xforms} %{?_without_xforms}

make MATHLIB=-lm %{?CCC} %{?CXX}


%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT

# .desktop entry
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
desktop-file-install --vendor fedora \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications \
  --add-category X-Fedora \
  %{SOURCE1}

# app icon 
install -D -m644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/pixmaps/%{name}.png

# move the html manual for inclusion later
mv doc/html .

# fixup info, We'll use install-info later
rm -f $RPM_BUILD_ROOT%{_infodir}/dir

# Manually install maniview manpage
%{?_with_maniview:install -D -m644 src/bin/maniview*/maniview.1 $RPM_BUILD_ROOT%{_mandir}/man1/maniview.1}


%clean
rm -rf $RPM_BUILD_ROOT


%post
/sbin/install-info --info-dir=%{_infodir} %{_infodir}/%{name}.gz ||:

%preun
if [ $1 -eq 0 ] ;then
  /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/%{name}.gz ||:
fi


%files
%defattr(-,root,root)
%doc AUTHORS ChangeLog COPYING INSTALL INSTALL.Geomview NEWS README
%doc html
%{_datadir}/applications/*.desktop
%{_datadir}/pixmaps/*
%{_bindir}/*
%{_infodir}/*
%{_mandir}/man?/*
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/.geomview
%{_datadir}/%{name}/geom
%{_datadir}/%{name}/cmap.fmap
%dir %{_libexecdir}/%{name}
%{_libexecdir}/%{name}/gvx
%{_libexecdir}/%{name}/animate
%{_libexecdir}/%{name}/.geomview-animate
%{_libexecdir}/%{name}/drawbdy
%{_libexecdir}/%{name}/.geomview-drawbdy

%if "%{?_with_xforms:1}" == "1"
%files plugins 
%defattr(-,root,root)
%{_libexecdir}/%{name}/example
%{_libexecdir}/%{name}/.geomview-example
%{_libexecdir}/%{name}/ginsu
%{_libexecdir}/%{name}/.geomview-ginsu
%{_libexecdir}/%{name}/graffiti
%{_libexecdir}/%{name}/.geomview-graffiti
%{_libexecdir}/%{name}/stereo
%{_libexecdir}/%{name}/.geomview-stereo
%{_libexecdir}/%{name}/sweep
%{_libexecdir}/%{name}/.geomview-sweep
%{_libexecdir}/%{name}/tackdown
%{_libexecdir}/%{name}/.geomview-tackdown
%{_libexecdir}/%{name}/transformer
%{_libexecdir}/%{name}/.geomview-transformer
%{_libexecdir}/%{name}/origin
%endif

%if "%{?_with_orrery:1}" == "1"
%files orrery 
%defattr(-,root,root)
%doc orrery*/README orrery*/NEWS orrery*/AUTHORS orrery*/ChangeLog 
%dir %{_datadir}/geomview/modules
%{_datadir}/geomview/modules/orrery
%{_libexecdir}/%{name}/.geomview-orrery
%endif

%if "%{?_with_maniview:1}" == "1"
%files maniview
%defattr(-,root,root)
%doc maniview*/README maniview*/NEWS maniview*/AUTHORS maniview*/ChangeLog
%{_datadir}/%{name}/groups
%{_libexecdir}/%{name}/maniview
%{_libexecdir}/%{name}/.geomview-maniview
%{_mandir}/man1/maniview*
%endif


%changelog
* Mon Sep 20 2004 Rex Dieter <rexdieter at sf.net> 0:1.8.1-0.fdr.10
- update Source URL
- fix un-owned /usr/share/geomview/modules
- Requires(post,preun): /sbin-install-info
- -orrery: Requires: tk
- License: LGPL, %%doc COPYING
- comment out the Obsoleting of subpkgs with using --without.  I think
  the logic there is wrong.
- relax subpkgs to Requires: %{name} = %%epoch:%%version

* Tue Sep 14 2004 Rex Dieter <rexdieter at sf.net> 0:1.8.1-0.fdr.9
- fix build for fc3
- remove unused gcc_ver cruft
- remove unused (by default) lesstif bits

* Mon Jul 19 2004 Rex Dieter <rexdieter at sf.net> 0:1.8.1-0.fdr.8
- .desktop Categories += Education;Math;

* Mon Jul 19 2004 Rex Dieter <rexdieter at sf.net> 0:1.8.1-0.fdr.7
- BR: libGL.so.1 libGLU.so.1

* Mon Jul 19 2004 Rex Dieter <rexdieter at sf.net> 0:1.8.1-0.fdr.6
- fix file list (possible dups)

* Mon Jul 19 2004 Rex Dieter <rexdieter at sf.net> 0:1.8.1-0.fdr.5
- BR: libtool flex
- BR: XFree86-devel (for lib{GL/GLU})

* Thu Jun 03 2004 Rex Dieter <rexdieter at sf.net> 0:1.8.1-0.fdr.4
- .desktop: Categories += Graphics

* Tue Mar 16 2004 Rex Dieter <rexdieter at sf.net> 0:1.8.1-0.fdr.3
- use patch from geomview sf site to allow gcc3. 
- use desktop-file-install

* Wed Sep 24 2003 Rex Dieter <rexdieter at sf.net> 0:1.8.1-0.fdr.2
- cleanup for formal submission to fedora.

* Fri Aug 08 2003 Rex Dieter <rexdieter at sf.net> 0:1.8.1-0.fdr.1
- Build against openmotif.

* Mon May 12 2003 Rex Dieter <rexdieter at users.sf.net> 0:1.8.1-0.fdr.0
- fedora'ize 
- rh73: link xforms static (for now, so rh80+ users could use if they
  want/need plugins/maniview subpkgs).
- rh80+: use g++296, no xforms.
- Obsoletes: subpkgs not built.

* Fri Jun 21 2002 Rex Dieter <rexdieter at users.sf.net> 1.8.1-8
- Obsoletes/Provides: pluginname=version-release for extra plugins
  (so to gracefully handle upgrade from Mark's orrery rpm)

* Fri Jun 21 2002 Rex Dieter <rexdieter at users.sf.net> 1.8.1-7
- use macros for all subpkgs
- include orrery-0.9.3.
- remove %_smp_mflags (makefile is not smp safe)

* Thu Jun 20 2002 Rex Dieter <rexdieter at users.sf.net> 1.8.1-6
- include maniview-2.0.0.
- include geomview info/man pages.

* Thu Feb 27 2002 Rex Dieter <rexdieter at users.sf.net> 1.8.1-5
- rebuild to link xforms dynamic

* Wed Feb 20 2002 Rex Dieter <rexdieter at users.sf.net> 1.8.1-4
- conditionally use xforms (no by default)
- make subpkg require %%name-%%version-%%release
- tweak to work with new lesstif

* Tue Dec 11 2001 Rex Dieter <rexdieter at users.sf.net> 1.8.1-3
- really use the app-icon this time.
- use Prefix to at least pretend relocatability

* Wed Nov 7 2001 Rex Dieter <rexdieter at users.sf.net> 1.8.1-2
- make -plugins subpkg for plugins that use xforms.

* Fri Oct 5 2001 Rex Dieter <rexdieter at users.sf.net > 1.8.1-1
- cleanup specfile
- make icon/desktop files
- include option to link xforms-static (untested)

* Fri Sep 28 2001 Rex Dieter <rexdieter at users.sf.net> 1.8.1-0
- first try. 
- TODO: make subpkgs manual(html), modules, modules-xforms

